//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormSettings.h"
#include "PluginSettings.h"
#include "DirectSoundScope.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmSettings *frmSettings;
//---------------------------------------------------------------------------
__fastcall TfrmSettings::TfrmSettings(TComponent* Owner)
	: TForm(Owner)
{
	cbSamplingSpeed->Items->Clear();
	std::vector<int> speeds = PluginSettings::getSamplingSpeedVector();
	for (unsigned int i=0; i<speeds.size(); i++)
	{
		cbSamplingSpeed->Items->Add(speeds[i]);
	}
}
//---------------------------------------------------------------------------

void TfrmSettings::SetDevicesList(std::vector<std::string> devices)
{
	cbCaptureDevices->Clear();
	for (unsigned int i=0; i<devices.size(); i++)
	{
		cbCaptureDevices->Items->Add(devices[i].c_str());
	}
	cbCaptureDevices->ItemIndex = cbCaptureDevices->Items->IndexOf(pluginSettings.asCaptureDevice);

	if (pluginSettings.asCaptureDevice == "" && cbCaptureDevices->Items->Count > 0)
		cbCaptureDevices->ItemIndex = 0;

	cbSamplingSpeed->ItemIndex = cbSamplingSpeed->Items->IndexOf(pluginSettings.samplingSpeed);
	if (cbSamplingSpeed->ItemIndex == -1)
	{
    	cbSamplingSpeed->ItemIndex = cbSamplingSpeed->Items->IndexOf(PluginSettings::DEFAULT_SAMPLING_SPEED);
	}

	edSens->Text = FloatToStr(pluginSettings.fSens);
	edOffset->Text = pluginSettings.offset;
}

void __fastcall TfrmSettings::cbCaptureDevicesChange(TObject *Sender)
{
	pluginSettings.asCaptureDevice = cbCaptureDevices->Text;
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::cbSamplingSpeedChange(TObject *Sender)
{
	if (cbSamplingSpeed->ItemIndex < 0)
		return;
	std::vector<int> speeds = PluginSettings::getSamplingSpeedVector();
	pluginSettings.samplingSpeed = speeds[cbSamplingSpeed->ItemIndex];
}
//---------------------------------------------------------------------------


void __fastcall TfrmSettings::tmrRefreshAverageValuesTimer(TObject *Sender)
{
	if (edAverageA->SelLength == 0)
	{
		edAverageA->Text = scope.GetAverageSample(0);
	}
	if (edAverageB->SelLength == 0)
	{
		edAverageB->Text = scope.GetAverageSample(1);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::edSensChange(TObject *Sender)
{
	try
	{
		pluginSettings.fSens = StrToFloat(edSens->Text);
	}
	catch(...)
	{
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::edOffsetChange(TObject *Sender)
{
	try
	{
		pluginSettings.offset = StrToInt(edOffset->Text);
	}
	catch(...)
	{
	}
}
//---------------------------------------------------------------------------

